!*******************************************************************
!
subroutine solid_body(ux,uy,uz,epsi,ppm,sy1,sy2,sy3,sy4,sy5,sy6,sy7,sy8,sy9,di1,di2)
!
!*******************************************************************

USE param
USE IBM 
USE variables

implicit none

real(8),dimension(nx,ny,nz) :: ux,uy,uz,epsi
real(8),dimension(nx,ny,nz) :: sy1,sy2,sy3
real(8),dimension(nx,ny,nz) :: sy4,sy5,sy6
real(8),dimension(nx,ny,nz) :: sy7,sy8,sy9,di1,di2
real(8),dimension(nxm,nym,nz) :: ppm


if (ivirtuel.eq.1) then
   call gradpression(ppm,sy1,sy2,sy3,sy4,sy5,sy6,sy7,sy8,sy9,di1,di2)
   call corgp_IBM(ux,uy,uz,sy1,sy2,sy3,1)
   call forcage_original(ux,uy,uz,epsi)
   call corgp_IBM(ux,uy,uz,sy1,sy2,sy3,2)
endif

return
end subroutine solid_body

!********************************************************************
!
subroutine corgp_IBM (ux,uy,uz,px,py,pz,nlock)
! 
!********************************************************************

USE param
USE IBM
USE variables

implicit none

integer :: ijk,nlock,nxyz
real(8),dimension(nx,ny,nz) :: ux,uy,uz,px,py,pz

nxyz=nx*ny*nz

if (nlock.eq.1) then
   if (nz.gt.1) then
      do ijk=1,nxyz
         uy(ijk,1,1)=-py(ijk,1,1)+uy(ijk,1,1) 
         uz(ijk,1,1)=-pz(ijk,1,1)+uz(ijk,1,1) 
         ux(ijk,1,1)=-px(ijk,1,1)+ux(ijk,1,1)
      enddo
   else
      do ijk=1,nxyz
         uy(ijk,1,1)=-py(ijk,1,1)+uy(ijk,1,1) 
         ux(ijk,1,1)=-px(ijk,1,1)+ux(ijk,1,1)
      enddo
   endif
endif
if (nlock.eq.2) then
   if (nz.gt.1) then
      do ijk=1,nxyz
         uy(ijk,1,1)=py(ijk,1,1)+uy(ijk,1,1) 
         uz(ijk,1,1)=pz(ijk,1,1)+uz(ijk,1,1) 
         ux(ijk,1,1)=px(ijk,1,1)+ux(ijk,1,1)
      enddo
   else
      do ijk=1,nxyz
         uy(ijk,1,1)=py(ijk,1,1)+uy(ijk,1,1) 
         ux(ijk,1,1)=px(ijk,1,1)+ux(ijk,1,1)
      enddo
   endif
endif

return
end subroutine corgp_IBM


!*******************************************************************
!
subroutine forcage_original(ux,uy,uz,epsi)
!
!*******************************************************************

USE param
USE IBM 
USE variables

implicit none

real(8),dimension(nx,ny,nz) :: ux,uy,uz,epsi
integer :: j, i, k, np, i2
real(8) :: xm,ym,r
real(8) :: d1,d2,d3,d4,aaa

if (nz==1) then
   np=0 
   epsi=0.
   do k=1,nz
   do j=1,ny 
   do i=1,nx
      xm=(i-1)*dx 
      ym=yp(j)
      r=sqrt((xm-cex)*(xm-cex)+(ym-cey)*(ym-cey)) 
      if (r-ra >= 0.) cycle
      ux(i,j,k)=0.
      uy(i,j,k)=0. 
      np=np+1 
      epsi(i,j,k)=1. 
   enddo
   enddo
   enddo
     do k=1,nz
   do j=1,ny
   do i=1,nx
      xm=(i-1)*dx
      ym=yp(j)
      r=sqrt((xm-cex)*(xm-cex)+(ym-cey+3.)*(ym-cey+3.))
      if (r-ra >= 0.) cycle
      ux(i,j,k)=0.
      uy(i,j,k)=0.
      np=np+1
      epsi(i,j,k)=1.
   enddo
   enddo
   enddo
     do k=1,nz
   do j=1,ny
   do i=1,nx
      xm=(i-1)*dx
      ym=yp(j)
      r=sqrt((xm-cex)*(xm-cex)+(ym-cey-3.)*(ym-cey-3.))
      if (r-ra >= 0.) cycle
      ux(i,j,k)=0.
      uy(i,j,k)=0.
      np=np+1
      epsi(i,j,k)=1.
   enddo
   enddo
   enddo

else
   np=0
   epsi=0.
   do k=1,nz
   do j=1,ny
   do i=1,nx
      xm=(i-1)*dx
      ym=yp(j)
      r=sqrt((xm-cex)*(xm-cex)+(ym-cey)*(ym-cey))
      if (r-ra >= 0.) cycle
      ux(i,j,k)=0.
      uy(i,j,k)=0.
      uz(i,j,k)=0.
      np=np+1
      epsi(i,j,k)=1.
   enddo
   enddo
   enddo
endif

!

return  
end subroutine forcage_original













