!********************************************************************
!
PROGRAM incompact3d
!
!********************************************************************
USE param
USE parfiX;USE parfiY;USE parfiZ
USE derivX;USE derivY;USE derivZ
USE aeroforce
USE variables

implicit none

real(8),dimension(nx,ny,nz) :: ux,uy,uz,gx,gy,gz,fx,fy,fz
real(8),dimension(nx,ny,nz,nphi) :: phi,phis,phiss
real(8),dimension(nx,ny,nz) :: sy1,sy2,sy3,sy4,sy5,sy6
real(8),dimension(mx,my,mz) :: sy7,sy8,sy9,sy10,sy11,sy12
real(8),dimension(nx,ny,nz) :: di1,di2,epsi
real(8),dimension(nxm,nym,nzm) :: ppm,ppm1
real(8),dimension(nx,ny,nz) :: uxm1,uym1,uzm1,uxm2,uym2,uzm2
real(8),dimension(nx,ny,nz) ::uxmt,uymt,uzmt,uxux,uyuy,uzuz,uxuy,uxuz,uyuz
!
real(8),dimension(mx,mz,ny/2,5) :: a,a2
real(8),dimension(mx,mz,ny,5) :: a3 
real(8),dimension(mx,mz,ny) :: d,d1,e,c
real(8),dimension(mx,mz) :: sr
real(8),dimension(mx,mz) :: a1,b1
!
real(8),dimension(nwork) :: work
real(8),dimension(100+2*(nxm+nym+nzm)) :: table
!
real(8),dimension(nxm,nym,nzm) :: epsidec
real(8),dimension(nx,ny,nz) :: px,py,pz,p_x,p_y,p_z
integer                     :: i,j,numvis
character(len=4) suffixe
!
real(8) :: theta,x,y,xmin,xmax,xmoyn,xmoyp
integer :: inumn,inump,imax,imin,jmin,jmax
!
!
   call parametre()
   call schemas()
   call waves ()  
   call initial (ux,uy,uz,gx,gy,gz,fx,fy,fz,phi,ppm)
!
   do itime=idebut,ifin
      t=(itime-1)*dt
      write(*,1001) itime,t
 1001 format('Time step =',i7,', Time unit =',F9.3)
      do itr=1,iavance_temps
         call inflow    (ux,uy,uz,phi)
         call outflow   (ux,uy,uz,phi)
         call convdiff  (ux,uy,uz,sy1,sy2,sy3,sy4,sy5,sy6,sy7,sy8,sy9,sy10,sy11,sy12,di1,di2)
         call intt      (ux,uy,uz,gx,gy,gz,sy7,sy8,sy9)


         call solid_body(ux,uy,uz,epsi,ppm,sy1,sy2,sy3,sy4,sy5,sy6,sy7,sy8,sy9,di1,di2)
         call pre_correc(ux,uy,uz)
         call divergence(ppm,ux,uy,uz,sy4,sy5,sy6,di1,di2,&
                         sy7,sy8,sy9,sy10,sy11,sy12,&
                         epsi,epsidec,sy1,sy2,sy3,work,table,1)
         call poisson   (ppm,sy7,sy8,sy9,sy10,sy11,sy12,&
                         work,table,a,a3,e,c,a2,sr,a1,b1,d1,d)
         call gradpression(ppm,p_x,p_y,p_z,sy4,sy5,sy6,sy7,sy8,sy9,di1,di2)
         call corgp       (ux,uy,uz,p_x,p_y,p_z)
         call divergence  (ppm1,ux,uy,uz,sy4,sy5,sy6,di1,di2,&
                           sy7,sy8,sy9,sy10,sy11,sy12,&
                           epsi,epsidec,sy1,sy2,sy3,work,table,2)
      enddo
      call stats (ux,uy,uz,gx,gy,gz,ppm,phi,phiss,epsi,&
                  sy1,sy2,sy3,sy4,sy5,sy6,di1,di2,sy7,sy8,sy9,&
                  uxm1,uym1,uzm1,uxm2,uym2,uzm2,p_x,p_y,p_z)
      call moyt(uxmt,uymt,uzmt,uxux,uyuy,uzuz,uxuy,uxuz,uyuz,ux,uy,uz)
   enddo
!
end PROGRAM incompact3d

